# JK-Build-Suite

A suite of build tools for providing dev ENV to JIKE, which is a formula = JK-* + IMPL + ENV. There is a list that explains what the factors stand for:

- `JK-*` - Basic, common and independent libraries/components, you would find them via filter [`jk-`](https://github.com/ruguoapp?utf8=%E2%9C%93&q=jk-).

- `IMPL` - An implentation of a special BLL requirement. Generally, the name prefix of IMPL projects is `jike-`.

- `ENV` - Nowadays, frondend projects must use build-structure to compile source files. But Webpack is suck, our code should be esay to run. Highly customizable build system will take days and days when initializing a project. So we need a unified and config-less build suite in dev environment.

## Installation
```
$ npm i --save-dev jk-build-suite
```

## CLI Usage
```bash
# Start a dev server, via Webpack Dev Server
$ jkbs start --config webpack.config.js

# Build source for production, via Webpack
$ NODE_ENV=production jkbs build --config webpack.config.js

# Upload static files to CDN, via Gulp
$ jkbs deploy 'dist/static/**' --output build-suite
```

## Configuration Template
```typescript
import {
  createWebpackConfig,
  mergeWebpackConfig
} from 'jk-build-suite'

const buildSuiteConfig = {
  DIST_DIR: 'dist'
}

const baseConfig = createWebpackConfig(
  buildSuiteConfig
)

const instanceConfig = {
  entry: {
    app: 'src/main'
  }
}

module.exports = mergeWebpackConfig(
  baseConfig,
  instanceConfig
)

```
The template is pithy, see the [`test/config`](test/config) directory for more complicated configurations.

## Supported Languages
- Template: HTML, EJS, Pug
- Style: CSS, Stylus
- Script: JavaScript, TypeScript, Vue

## License
[MIT](./LICENSE)
