"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
exports.__esModule = true;
var loaderOptionsMerge = require('webpack-loader-options-merge');
var entry_1 = require("./entry");
var output_1 = require("./output");
var resolve_1 = require("./resolve");
var dev_1 = require("./dev");
var loaders_1 = require("./loaders");
var plugins_1 = require("./plugins");
var config_1 = require("../config");
__export(require("./entry"));
__export(require("./output"));
__export(require("./resolve"));
__export(require("./dev"));
__export(require("./loaders"));
__export(require("./plugins"));
exports.webpackMerge = require('webpack-merge');
exports.mergeWebpackConfig = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var mergedConfig = exports.webpackMerge.apply(void 0, args);
    return loaderOptionsMerge(mergedConfig);
};
exports.createWebpackConfig = function (bsConfig) {
    config_1.updateConfig(bsConfig);
    return {
        cache: true,
        // Entry
        entry: entry_1.WEBPACK_ENTRY(),
        // Output
        output: output_1.WEBPACK_OUTPUT(),
        // Resolve
        resolve: resolve_1.WEBPACK_RESOLVE(),
        // Dev
        devtool: dev_1.WEBPACK_DEV_TOOL(),
        devServer: dev_1.WEBPACK_DEV_SERVER(),
        // Loaders
        module: {
            rules: loaders_1.WEBPACK_LOADERS()
        },
        // Plugins
        plugins: plugins_1.WEBPACK_PLUGINS()
    };
};
