"use strict";
exports.__esModule = true;
var ip = require('ip');
var utils_1 = require("./utils");
var config_1 = require("../config");
var env_1 = require("../env");
var DEFAULT_HOST = 'localhost';
exports.getAbsolutePublicPath = function () {
    if (env_1.$isProd) {
        return config_1.CONFIG.CDN_HOST + "/" + config_1.CONFIG.PREFIX;
    }
    else {
        var host = config_1.CONFIG.CDN_HOST
            .replace(DEFAULT_HOST, ip.address());
        return host + ":" + config_1.CONFIG.PORT + "/";
    }
};
exports.WEBPACK_OUTPUT = function () {
    var filename = utils_1.assetsPath('scripts/[name].[hash].js');
    var chunkFilename = utils_1.assetsPath('scripts/[id].[hash].js');
    var path = env_1.PROJECT_ROOT + "/" + config_1.CONFIG.DIST_DIR + "/";
    var publicPath = exports.getAbsolutePublicPath();
    return {
        filename: filename,
        chunkFilename: chunkFilename,
        path: path,
        publicPath: publicPath
    };
};
