"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
exports.__esModule = true;
var ExtractTextPlugin = require('extract-text-webpack-plugin');
var config_1 = require("../config");
exports.assetsPath = function (path) {
    return config_1.CONFIG.ASSETS_DIR + "/" + path;
};
exports.cssLoaders = function (options) {
    options = options || {};
    // generate loader string to be used with extract text plugin
    var generateLoaders = function (loaders) {
        var sourceLoader = loaders.map(function (loader) {
            var extraParamChar = '';
            if (/\?/.test(loader)) {
                loader = loader.replace(/\?/, '-loader?');
                extraParamChar = '&';
            }
            else {
                loader = loader + '-loader';
                extraParamChar = '?';
            }
            if (options.sourceMap) {
                extraParamChar += 'sourceMap';
            }
            if (loader === 'css-loader' && options.cssModules) {
                extraParamChar += '&modules&localIdentName=[local]-[hash:base64:5]';
            }
            if (loader === 'stylus-loader') {
                if (options.cssModules) {
                    loader += '&include css';
                }
            }
            return loader + extraParamChar;
        }).join('!');
        if (options.extract) {
            return ExtractTextPlugin.extract({
                fallback: 'style-loader',
                use: sourceLoader
            });
        }
        else {
            return ['style-loader', sourceLoader].join('!');
        }
    };
    return {
        css: generateLoaders(['css', 'postcss']),
        scss: generateLoaders(['css', 'postcss', 'sass']),
        styl: generateLoaders(['css', 'postcss', 'stylus?resolve url'])
    };
};
// Generate rules for standalone style files
exports.styleRules = function (options) {
    options = options || {};
    var output = [];
    var NODE_MODULES = /node_modules/;
    var loaders = exports.cssLoaders(options);
    var action = options.extract ? 'use' : 'loader';
    var exclude = options.cssModules ? NODE_MODULES : /noparse-/;
    if (options.cssModules) {
        var noModulesOptions = __assign({}, options, { cssModules: false });
        var noModulesLoaders = exports.cssLoaders(noModulesOptions);
        for (var extension in noModulesLoaders) {
            var loader = noModulesLoaders[extension];
            var noModulesRule = (_a = {
                    test: new RegExp('\\.' + extension + '$')
                },
                _a["" + action] = loader,
                _a.include = NODE_MODULES,
                _a);
            output.push(noModulesRule);
        }
    }
    for (var extension in loaders) {
        var loader = loaders[extension];
        var rule = (_b = {
                test: new RegExp('\\.' + extension + '$')
            },
            _b["" + action] = loader,
            _b.exclude = exclude,
            _b);
        output.push(rule);
    }
    return output;
    var _a, _b;
};
