import { $isProd } from './env'

export interface ConfigSchema {
  PREFIX?: string
  PORT?: number
  CDN_HOST?: string
  DIST_DIR?: string
  ASSETS_DIR?: string
  CSS_MODULES?: boolean
  PX_TO_REM?: boolean
}

export const CONFIG: ConfigSchema = {
  PREFIX: '',
  PORT: 8081,
  CDN_HOST: 'http://localhost',
  DIST_DIR: 'dist',
  ASSETS_DIR: 'static',
  CSS_MODULES: false,
  PX_TO_REM: false
}

export const updateConfig = (newConfig: ConfigSchema): void => {
  (<any>Object).assign(CONFIG, newConfig)
}

if ($isProd) {
  const prodConfig: ConfigSchema = {
    CDN_HOST: 'https://cdn.ruguoapp.com'
  }

  updateConfig(prodConfig)
}
