const ip = require('ip')

import { Output } from 'webpack'
import { assetsPath } from './utils'
import { CONFIG } from '../config'
import { PROJECT_ROOT, $isProd } from '../env'

const DEFAULT_HOST = 'localhost'

export const getAbsolutePublicPath = () => {
  if ($isProd) {
    return `${CONFIG.CDN_HOST}/${CONFIG.PREFIX}`
  } else {
    const host = CONFIG.CDN_HOST
      .replace(
        DEFAULT_HOST,
        ip.address()
      )
    return `${host}:${CONFIG.PORT}/`
  }
}

export const WEBPACK_OUTPUT = (): Output => {
  const filename      = assetsPath('scripts/[name].[hash].js')
  const chunkFilename = assetsPath('scripts/[id].[hash].js')
  const path          = `${PROJECT_ROOT}/${CONFIG.DIST_DIR}/`
  const publicPath    = getAbsolutePublicPath()

  return {
    filename,
    chunkFilename,
    path,
    publicPath
  }
}
