import * as path from 'path'
import {
  Configuration,
  DefinePlugin,
  optimize
} from 'webpack'
import {
  CONFIG,
  createWebpackConfig,
  mergeWebpackConfig,
  ConfigSchema
} from '../lib'

const buildSuiteConfig: ConfigSchema = {
  PREFIX: 'jkbs-test/',
  DIST_DIR: 'test/dist/cssmodules',
  CSS_MODULES: true
}

const baseConfig = createWebpackConfig(
  buildSuiteConfig
)

const appConfigVariable = CONFIG

const instanceConfig = {
  entry: {
    common: [
      path.resolve(__dirname, '../fixtures/common')
    ],
    app: [
      path.resolve(__dirname, '../fixtures/main')
    ]
  },

  plugins: [
    new DefinePlugin({
      __CONFIG__: JSON.stringify(appConfigVariable)
    }),

    new optimize.CommonsChunkPlugin({
      name: 'common',
      minChunks: Infinity
    })
  ]
}

export const cssModulesConfig: Configuration = mergeWebpackConfig(
  baseConfig,
  instanceConfig
)
