import * as path from 'path'
import { Configuration } from 'webpack'

import {
  createWebpackConfig,
  mergeWebpackConfig,
  ConfigSchema
} from '../lib'

const buildSuiteConfig: ConfigSchema = {
  PREFIX: 'jkbs-test/',
  DIST_DIR: 'test/dist/postcss',
  PX_TO_REM: true
}

const baseConfig = createWebpackConfig(
  buildSuiteConfig
)

const instanceConfig = {
  entry: path.resolve(__dirname, '../fixtures/main')
}

export const customPostCssConfig: Configuration = mergeWebpackConfig(
  baseConfig,
  instanceConfig
)
