/// <reference path='./global.d.ts' />

import './background.scss'
import './main.styl'
import './es6'
import './vue-test'

import * as React from 'react'
import { render } from 'react-dom'
import { App } from './app'
import { HotModuleReload } from './hot-module-reload'

const $root = document.createElement('div')
document.body.appendChild($root)

const renderReactApp = (RootComponent) => {
  render(
    <HotModuleReload>
      <RootComponent />
    </HotModuleReload>,
    $root
  )
}

document.addEventListener('DOMContentLoaded', () => {
  renderReactApp(App)
})

if (module.hot) {
  module.hot.accept('./app', () => {
    const NextRoot = require('./app').App
    renderReactApp(NextRoot)
  })
}
