import * as path from 'path'
import { expect } from 'chai'
import {
  WEBPACK_OUTPUT,
  WEBPACK_RESOLVE
} from '../lib'

describe('Webpack Config', () => {

  describe('Output', () => {

    it('Filname ext is `.js`', () => {
      const result   = path.parse(WEBPACK_OUTPUT().filename).ext
      const expected = '.js'

      expect(result).to.equal(expected)
    })

    it('PublicPath is not match local', () => {
      const result     = WEBPACK_OUTPUT().publicPath
      const unexpected = /localhost/

      expect(result).to.not.match(unexpected)
    })

  })

  describe('Resolve', () => {

    it('Extensions include `.js` and `.ts`', () => {
      const result   = WEBPACK_RESOLVE().extensions
      const expectedJS = '.js'
      const expectedTS = '.ts'

      expect(result).to.include(expectedJS)
      expect(result).to.include(expectedTS)
    })

  })

})
